<html>
<head>
<title>PHP Blowfish: LiteFish Constants Generator | Killing Moon Software</title>
</head>
<body>
<?
/*
 * Create LiteFish constants include file
 */
 
require_once "litefish_key.inc";
require_once "blowfish_constants.inc";
require_once "blowfish.inc";

// Initialise Blowfish
$blowfish_defaults = new blowfish_defaults_object();
$blowfish = new blowfish_cipher( $blowfish_defaults );

// Set the key
$blowfish->setKey( $litefish_key );

// Create the LiteFish defaults file contents from current Blowfish object
$s = "<?\nclass litefish_defaults_object\n{\n";
$s .= array_dump( "blowfish_P", $blowfish->blowfish_P ) . "\n";
$s .= array_dump( "blowfish_S1", $blowfish->blowfish_S1 ) . "\n";
$s .= array_dump( "blowfish_S2", $blowfish->blowfish_S2 ) . "\n";
$s .= array_dump( "blowfish_S3", $blowfish->blowfish_S3 ) . "\n";
$s .= array_dump( "blowfish_S4", $blowfish->blowfish_S4 );
$s .= "}\n?>";

// Write the file
$fp = fopen( $litefish_include_filename, "w" );
fwrite( $fp, $s );
fclose( $fp );

// Display new key

echo "LiteFish Key set to \"$litefish_key\"<br>";

// END.

/*
 * SUBROUTINES
 */
 
// Display a single array
function array_dump( $name, $data )
{
	$lineMax = 6; // Number of values per line
	$count = count( $data );
	$s = '';
	for( $i=0; $i<$count; ++$i )
	{
		if( $s != '' )
		{
			if( !( $i % $lineMax ) ) $s .= ",\n\t\t";
			else $s .= ', ';
		}
		$s .= sprintf( "0x%08X", $data[ $i ] );
	}
	return "\tvar \$$name = array(\n\t\t" . $s ."\n\t);\n";
}
?>
</body>
</html>