<html>
<head>
<title>PHP Blowfish: LiteFish Test | Killing Moon Software</title>
</head>
<body>
<?
require_once "litefish_key.inc";
require_once "blowfish_constants.inc";
require_once "blowfish.inc";
require_once $litefish_include_filename;

// Initialise the Blowfish Object with LiteFish key
$blowfish_defaults = new blowfish_defaults_object();
$blowfish = new blowfish_cipher( $blowfish_defaults );
$blowfish->setKey( $litefish_key );

// Initialise LiteFish
$litefish_defaults = new litefish_defaults_object();
$litefish = new litefish_cipher( $litefish_defaults );

// A list of test plaintexts
$tests = array(
	"1234567890",
	"abcdefghijklmnopqrstuvwxyz",
	"ABCEDFGHIJKLMNOPQRSTUVWXYZ",
	"The quick brown fox jumps over the lazy dog."
	);

// Iterate through each of the tests
for( $i = 0; $i < count( $tests ); ++$i )
{
	// Display the plaintext
	$plainText = $tests[ $i ];
	echo "<h3>$plainText</h3><p>";

	// The decrypted output will be zero, padded, so make the input equal.
	for( $j = strlen( $plainText ); $j % 8; ++$j ) $plainText[ $j ] = chr(0);
	
	// Encrypt with both objects
	$blowfish_encrypted = $blowfish->encrypt( $plainText );
	$litefish_encrypted = $litefish->encrypt( $plainText );

	// Check that they both encrypt to give the same ciphertext
	if( $blowfish_encrypted == $litefish_encrypted ) echo "Encryption OK<br>";
	else echo "<b>Encryption failed</b><br>";

	// Now, decrypt the ciphertext with litefish
	$litefish_decrypted = $litefish->decrypt( $blowfish_encrypted );

	// Check that the decrypted plaintext is the same as the original plaintext
	if( $litefish_decrypted == $plainText ) echo "Decryption OK<br>";
	else echo "<b>Decryption Failed</b><br>";

	// Close paragraph tag for this test
	echo '</p>';
}
?>
</body>
</html>